From 2bcd81ee9ccb8de4751048eea124771d7e377a99 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Wed, 15 Feb 2012 12:39:58 -0600
Subject: Option to repeat gradebook headers

---
 grade/report/grader/lib.php              |   26 ++++++++++++++++++++++++--
 grade/report/grader/preferences_form.php |    1 +
 grade/report/grader/settings.php         |    3 +++
 lang/en/grades.php                       |    2 ++
 4 files changed, 30 insertions(+), 2 deletions(-)

diff --git a/grade/report/grader/lib.php b/grade/report/grader/lib.php
index bcacf6d..e42c78b 100644
--- a/grade/report/grader/lib.php
+++ b/grade/report/grader/lib.php
@@ -614,11 +614,23 @@ class grade_report_grader extends grade_report {
 
         $rowclasses = array('even', 'odd');
 
+        $repeat = $this->get_pref('repeatheaders');
+
+        // Repeat filler
+        $repeatentries = unserialize(serialize($rows));
+
         $suspendedstring = null;
         foreach ($this->users as $userid => $user) {
+            if ($this->rowcount > 0 and $this->rowcount % $repeat == 0) {
+                $rows = array_merge($rows, $repeatentries);
+            }
+
+            $this->rowcount++;
+
             $userrow = new html_table_row();
+
             $userrow->id = 'fixed_user_'.$userid;
-            $userrow->attributes['class'] = 'r'.$this->rowcount++.' '.$rowclasses[$this->rowcount % 2];
+            $userrow->attributes['class'] = $rowclasses[$this->rowcount % 2];
 
             $usercell = new html_table_cell();
             $usercell->attributes['class'] = 'user';
@@ -711,6 +723,7 @@ class grade_report_grader extends grade_report {
             $headingrow->attributes['class'] = 'heading_name_row';
 
             foreach ($row as $columnkey => $element) {
+
                 $sortlink = clone($this->baseurl);
                 if (isset($element['object']->id)) {
                     $sortlink->param('sortitemid', $element['object']->id);
@@ -822,8 +835,17 @@ class grade_report_grader extends grade_report {
 
         $rowclasses = array('even', 'odd');
 
+        $repeat = $this->get_pref('repeatheaders');
+
+        // Headers to repeat
+        $repeatentries = unserialize(serialize($rows));
+
         foreach ($this->users as $userid => $user) {
 
+            if ($this->rowcount > 0 and $this->rowcount % $repeat == 0) {
+                $rows = array_merge($rows, $repeatentries);
+            }
+
             if ($this->canviewhidden) {
                 $altered = array();
                 $unknown = array();
@@ -835,6 +857,7 @@ class grade_report_grader extends grade_report {
             }
 
 
+            $this->rowcount++;
             $itemrow = new html_table_row();
             $itemrow->id = 'user_'.$userid;
             $itemrow->attributes['class'] = $rowclasses[$this->rowcount % 2];
@@ -1065,7 +1088,6 @@ class grade_report_grader extends grade_report {
 
         $html = '';
 
-
         if ($fixedstudents) {
             $fixedcolumntable = new html_table();
             $fixedcolumntable->id = 'fixed_column';
diff --git a/grade/report/grader/preferences_form.php b/grade/report/grader/preferences_form.php
index 93f4c03..3066b7b 100644
--- a/grade/report/grader/preferences_form.php
+++ b/grade/report/grader/preferences_form.php
@@ -103,6 +103,7 @@ class grader_report_preferences_form extends moodleform {
         // View capability is the lowest permission. Users with grade:manage or grade:edit must also have grader:view
         if (has_capability('gradereport/grader:view', $context)) {
             $preferences['prefgeneral']['studentsperpage'] = 'text';
+            $preferences['prefgeneral']['repeatheaders'] = 'text';
             $preferences['prefgeneral']['aggregationposition'] = array(GRADE_REPORT_PREFERENCE_DEFAULT => '*default*',
                                                                        GRADE_REPORT_AGGREGATION_POSITION_FIRST => get_string('positionfirst', 'grades'),
                                                                        GRADE_REPORT_AGGREGATION_POSITION_LAST => get_string('positionlast', 'grades'));
diff --git a/grade/report/grader/settings.php b/grade/report/grader/settings.php
index c795b33..6e1fff5 100644
--- a/grade/report/grader/settings.php
+++ b/grade/report/grader/settings.php
@@ -28,6 +28,9 @@ if ($ADMIN->fulltree) {
     $settings->add(new admin_setting_configtext('grade_report_studentsperpage', get_string('studentsperpage', 'grades'),
                                             get_string('studentsperpage_help', 'grades'), 100));
 
+    $settings->add(new admin_setting_configtext('grade_report_repeatheaders', get_string('repeatheaders', 'grades'),
+                                            get_string('repeatheaders_help', 'grades'), 10));
+
     $settings->add(new admin_setting_configcheckbox('grade_report_quickgrading', get_string('quickgrading', 'grades'),
                                                 get_string('quickgrading_help', 'grades'), 1));
 
diff --git a/lang/en/grades.php b/lang/en/grades.php
index b583eff..79519e2 100644
--- a/lang/en/grades.php
+++ b/lang/en/grades.php
@@ -509,6 +509,8 @@ $string['realpercentage'] = 'Real (percentage)';
 $string['regradeanyway'] = 'Regrade anyway';
 $string['removeallcoursegrades'] = 'Delete all grades';
 $string['removeallcourseitems'] = 'Delete all items and categories';
+$string['repeatheaders'] = 'Repeat Headers';
+$string['repeatheaders_help'] = 'Repeat gradebook headers after this many rows.';
 $string['report'] = 'Report';
 $string['reportdefault'] = 'Report default ({$a})';
 $string['reportplugins'] = 'Report plugins';
-- 
1.7.1


